/** 
 *   FIXME ....
 *
 *   (c) Copyright 2003 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 *   TODO: ???
 **/

#ifndef _ENCODERS_H
#define _ENCODERS_H

#include "e5850.h"

#define RA_CASE  1  /* only 0 or 1 */
#define DEC_CASE 0  /* only 0 or 1 */

struct encoders_data{
	int val[2];
	int encoder[2];
	int factor[2];
	int old[2];
#if USE_ANEMOMETER
	int anemometer;
#endif
	/* .... */
};

extern int encoder_num[];

int encoders_open(int ra, int dec);
int encoders_close(int fd);

#ifndef ENCODERS_HW /* if not use iar bus */
int encoders_buff_len(int fd);
int encoders_clear_buff(int fd);
int encoders_is_running(int fd);
int encoders_stop(int fd);
int encoders_start(int fd);
//int encoders_get_raw_data(int fd, struct encoders_data *d);
int encoders_get_next_data(int fd, struct encoders_data *en);
int get_encoder(int fd, int num);
int encoder_set_cw(int fd, int num);
int encoder_set_ccw(int fd, int num);
int encoder_set_zero(int fd, int num);
int encoder_set_toggle_zero(int fd, int num);
int sidereal_clock_running(int fd);
int put_on_fail_condition(int fd);
int put_on_normal_condition(int fd);
int get_anemometer(int fd);
#else
extern int encoders_done;
int encoders_core(int fd, int fd_bus);
#endif

#endif  /* ifndef _ENCODERS_H */



