/** 
 *   FIXME ....
 *
 *   (c) Copyright 2005 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 *   TODO: ???
 **/
#define _GNU_SOURCE

#include <stdlib.h>
#include <string.h>

#include "my_stdio.h"
#include "socket_client.h"
#include "iar_bus.h"
#include "antenna_ib_pk.h"

/*****************************************************************************
 * local functions:
 **/
static int survey_send_cmd(int fd, int cmd)
{
	struct ib_packet pk;
	struct antenna_packet *anp;
	int ret;
	int l;

	memset(&pk, 0, sizeof(struct ib_packet));
	anp = (struct antenna_packet *)&pk.data;
	l = sizeof(struct antenna_packet_head);
	anp->h.cmd = cmd;
	anp->h.size = 0;
	ibus_send_data_to(fd, SURVEY_BUS_ADDR, anp, l);

	ret = ibus_read(fd, &pk);
	if( ret > 0) {
		ret = atoi(anp->data);
		PVERB(PINFO,"# val ret: %d\n", ret);
	}

	return ret;
}

/*
 * local functions END.
 *****************************************************************************/


int survey_start(int fd)
{
	return survey_send_cmd(fd, SCM_SURVEY_START);
}


int survey_stop(int fd)
{
	return survey_send_cmd(fd, SCM_SURVEY_STOP);
}


char *survey_status(int fd)
{
	struct ib_packet pk;
	struct antenna_packet *anp;
	int ret;
	int l;
	char *message = NULL;

	memset(&pk, 0, sizeof(struct ib_packet));
	anp = (struct antenna_packet *)&pk.data;
	l = sizeof(struct antenna_packet_head);
	anp->h.cmd = SCM_SURVEY_STATUS;
	anp->h.size = 0;
	ibus_send_data_to(fd, SURVEY_BUS_ADDR, anp, l);

	ret = ibus_read(fd, &pk);
	if (anp->h.size) {
		message = (char *) malloc(anp->h.size * sizeof(char) + 1);
		memcpy(message, anp->data, anp->h.size);
		*(message+anp->h.size) = 0;
		PVERB(PINFO,"# msg ret: %s\n", message);
	}

	return message;
}


